#include <iostream>
using namespace std;

//=============================================================================
// p:
//=============================================================================

// p has tuples (1,11,111), (2, 21, 211):

typedef int p_cursor_pos;

class p_cursor_1_2_3 {
private:
	int Row;
	int Col_1;
	int Col_2;
	int Col_3;

	bool set_data()
	{
		switch(Row) {
		case 1:
			Col_1 = 1;
			Col_2 = 11;
			Col_3 = 111;
			break;
		case 2:
			Col_1 = 1;
			Col_2 = 11;
			Col_3 = 112;
			break;
		case 3:
			Col_1 = 1;
			Col_2 = 12;
			Col_3 = 121;
			break;
		case 4:
			Col_1 = 2;
			Col_2 = 21;
			Col_3 = 211;
			break;
		default:
			Col_1 = -1;
			Col_2 = -1;
			Col_3 = -1;
			return false;
		}
		return true;
	}

public:
	p_cursor_1_2_3()
	{
		Row = -1;
		Col_1 = -1;
		Col_2 = -1;
		Col_2 = -1;
	}

	void open()
	{
		Row = 0;
	}

	bool fetch()
	{
		if(Row < 0) {
			cerr << "p_cursor_1_2_3 not open.\n";
			return false;
		}
		Row++;
		return set_data();
	}

	int col_1()
	{
		return Col_1;
	}

	int col_2()
	{
		return Col_2;
	}

	int col_3()
	{
		return Col_3;
	}

	p_cursor_pos position()
	{
		return Row;
	}

	void restore(p_cursor_pos pos)
	{
		Row = pos;
		(void) set_data();
	}

	void close()
	{
		Row = -1;
		Col_1 = -1;
		Col_2 = -1;
		Col_3 = -1;
	}
};

//=============================================================================
// q:
//=============================================================================

// q has tuples (3,31), (3,32), (4,41):

typedef int q_cursor_pos;

class q_cursor_1_2 {
private:
	int Row;
	int Col_1;
	int Col_2;

	bool set_data()
	{
		switch(Row) {
		case 1:
			Col_1 = 3;
			Col_2 = 31;
			break;
		case 2:
			Col_1 = 3;
			Col_2 = 32;
			break;
		case 3:
			Col_1 = 4;
			Col_2 = 41;
			break;
		default:
			Col_1 = -1;
			Col_2 = -1;
			return false;
		}
		return true;
	}

public:
	q_cursor_1_2()
	{
		Row = -1;
		Col_1 = -1;
		Col_2 = -1;
	}

	void open()
	{
		Row = 0;
	}

	bool fetch()
	{
		if(Row < 0) {
			cerr << "q_cursor_2 not open.\n";
			return false;
		}
		Row++;
		return set_data();
	}

	int col_1()
	{
		return Col_1;
	}

	int col_2()
	{
		return Col_2;
	}

	q_cursor_pos position()
	{
		return Row;
	}

	void restore(q_cursor_pos pos)
	{
		Row = pos;
		(void) set_data();
	}

	void close()
	{
		Row = -1;
		Col_1 = -1;
		Col_2 = -1;
	}
};

//=============================================================================
// Rule implementation:
//=============================================================================


// p(X1, X2, X3) & q(Y1, Y2)
// Gewuenschte Sortierung: X1, Y1, X2, Y2, X3

void print(int X1, int Y1, int X2, int Y2, int X3)
{
	cout << "X1 = " << X1 << ", Y1 = " << Y1
		<< ", X2 = " << X2 << ", Y2 = " << Y2
		<< ", X3 = " << X3 << "\n";
}

main()
{
p_cursor_1_2_3 p;
q_cursor_1_2 q;
bool more_p;
bool more_q;
int X1, X2, X3;
int Y1, Y2;

// Test of p:
cout << "p_1_2_3:\n";
p.open();
while(p.fetch()) {
	cout << p.col_1() << ", " << p.col_2() << ", " << p.col_3() << "\n";
}
p.close();
cout << "\n";

// Test of q:
cout << "q_1_2:\n";
q.open();
while(q.fetch()) {
	cout << q.col_1() << ", " << q.col_2() << "\n";
}
q.close();
cout << "\n";

// Main Part:
cout << "p(X1, X2, X3) & q(Y1, Y2)  ordered by X1, Y1, X2, Y2, X3:\n";
p.open();
more_p = p.fetch();
while(more_p) { // Loop over X1-values from p
	X1 = p.col_1();
	p_cursor_pos x1_start = p.position();
	q.open();
	more_q = q.fetch();
	while(more_q) { // Loop over Y1-values from q
		Y1 = q.col_1();
		q_cursor_pos y1_start = q.position();
		p.restore(x1_start);
		do { // Loop over X2-values from p
			p_cursor_pos x2_start = p.position();
			X2 = p.col_2();
			q.restore(y1_start);
			do { // Loop over Y2-values from q
				Y2 = q.col_2();
				p.restore(x2_start);
				do { // Loop over X3-values from p
					X3 = p.col_3();
					print(X1, Y1, X2, Y2, X3);
				} while((more_p = p.fetch()) &&
					p.col_1() == X1 && p.col_2() == X2);
			} while((more_q = q.fetch()) && q.col_1() == Y1);
		} while(more_p && p.col_1() == X1);
	}
	q.close();
}
p.close();

}

